import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsNetdisk {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  ParentId!: IType<number, bigint>;
  UserId!: IType<number, bigint>;
  Name?: string;
  Size!: IType<number, bigint>;
  Type?: string;
  Hash?: string;
  Folder!: unknown;
  Path?: string;
  Sort!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsNetdiskSchema = defineEntity({
  class: ScsNetdisk,
  comment: '文件收藏',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    ParentId: p.bigint().name('ParentId').columnType('bigint').comment('父ID').index('idx_SCS_NetDisk_01'),
    UserId: p.bigint().name('UserId').columnType('bigint').comment('用户id').index('idx_SCS_NetDisk_02'),
    Name: p.string().name('Name').nullable().comment('文件/文件夹名称').index('idx_SCS_NetDisk_03'),
    Size: p.bigint().name('Size').columnType('bigint').comment('文件/文件夹大小'),
    Type: p.string().name('Type').nullable().comment('文件类型'),
    Hash: p.string().name('Hash').nullable().comment('文件哈希值'),
    Folder: p.array().name('Folder').comment('是否文件夹'),
    Path: p.string().name('Path').nullable().comment('路径'),
    Sort: p.integer().name('Sort').comment('排序'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
